//
//  ICSCalendarItem.h
//  iCal to KS2
//
//  Created by FUJIDANA on 05/05/11.
//  Copyright 2005 FUJIDANA. All rights reserved.
//
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions
// are met:
// 1. Redistributions of source code must retain the above copyright
//    notice, this list of conditions and the following disclaimer.
// 2. Redistributions in binary form must reproduce the above copyright
//    notice, this list of conditions and the following disclaimer in the
//    documentation and/or other materials provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
// OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
// IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
// INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
// NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
// DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
// THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
// THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


#import <Foundation/Foundation.h>

@interface ICSCalendarItem : NSObject <NSCopying> {
	NSString		*identifier;
	
	NSString		*summary;
	NSString		*notes;
	int				sequence;
	NSCalendarDate	*stampDate;
	NSString		*url;
}

#pragma mark -
#pragma mark class methods
+ (NSDictionary *)dictionaryWithRFC2425Representation:(NSString *)string;
+ (NSArray *)arrayWithRFC2425Representation:(NSString *)string;
+ (NSString *)stringWithEscapedString:(NSString *)string;

#pragma mark -
#pragma mark initialization and deallocation
- (id) initWithIdentifier:(NSString *)anIdentifier;

#pragma mark accessor methods
- (NSString *)identifier;

- (NSString *)summary;
- (void)setSummary:(NSString *)value;

- (NSString *)notes;
- (void)setNotes:(NSString *)value;

- (int)sequence;
- (void)setSequence:(int)value;

- (NSCalendarDate *)stampDate;
- (void)setStampDate:(NSCalendarDate *)value;

- (NSString *)url;
- (void)setUrl:(NSString *)value;


@end
